package jdk.management.resource.internal.inst;

import java.io.IOException;
import jdk.management.resource.internal.ResourceIdImpl;
import jdk.management.resource.internal.ApproverGroup;
import java.net.InetAddress;
import jdk.internal.instrumentation.InstrumentationMethod;
import jdk.internal.instrumentation.InstrumentationTarget;

@InstrumentationTarget("sun.security.ssl.BaseSSLSocketImpl")
abstract class BaseSSLSocketImplRMHooks
{
    BaseSSLSocketImplRMHooks() {
    }
    
    @InstrumentationMethod
    boolean isLayered() {
        return this.isLayered();
    }
    
    @InstrumentationMethod
    public final InetAddress getLocalAddress() {
        return this.getLocalAddress();
    }
    
    @InstrumentationMethod
    public final boolean isBound() {
        return this.isBound();
    }
    
    @InstrumentationMethod
    public void close() throws IOException {
        if (this.isLayered() && this.isBound()) {
            ApproverGroup.SOCKET_OPEN_GROUP.getApprover(this).request(-1L, ResourceIdImpl.of(this.getLocalAddress()));
        }
        this.close();
    }
}
